# mptcplib

## About
A Python extension module for Multipath TCP. The core of this library is written in C. The purpose is to deliver kernel support of Multipath TCP in Python quicker than the standard CPython. Hopefully this library will be supported in the standard distribution. For a deeper read about Multipath TCP, please consult this [webpage](https://obonaventure.github.io/mmtp-book/).

## Table of content

- Example Usage
- Description
- License

## Example Usage
---

To be able to use the library we encourage to install using [PyPi](https://pypi.org/). Run the following command:

```
pip install mptcplib
```

In order to check if a socket created is still a MPTCP socket, you can use the following example :
```python
import mptcplib

with mptcplib.create_mptcpsocket(socket.AF_INET, socket.SOCK_STREAM) as sock:
    ... # Do other things
    if mptcplib.socket_is_mptcp(sock.fileno()):
        ... # Do things for MPTCP socket
    else:
        ... # Falled back to TCP
```

There are other useful functions such as getting the number of subflows used by to a MPTCP connection. We intend to make a Sphinx doc website will be soon available soon.

## Description
---

The library is currently supported on Linux kernels but the goal will be to extend it to MacOS. Below is a table containing operating systems that supports Multipath TCP and the level of support mptcplib offers.

| Operating System | mptcplib support | 
| ----------- | :-----------: |
| MacOS (Big Sur, Ventura) | Not yet |
| Ubuntu (>= 22.04) | Yes |
| CentOS | TBA |
| Debain | TBA |

## Contributing
---
Pull requests are more than welcome. For major changes, please open an issue discussing what you would like to change.

## License
---
The repository is under the MIT License, leaving enough freedom to enable wanting to play around with the code base.
