from distutils.core import setup, Extension

linux_modules = Extension("mptcplib._mptcplib_linux", 
                    include_dirs=["mptcplib/include"],
                    sources=["mptcplib/src/_mptcplib_linux.c"]
                )
long_description = ""
with open('README.md') as file:
    long_description = file.read()

setup(
    name="mptcplib", 
    version="0.0.3", 
    description="A Multipath TCP python support library",
    ext_modules=[linux_modules],
    package_data={
        "mptcplib": ["py.typed", "*.pyi", "**/*.pyi"]
    }, 
    long_description=long_description,
    long_description_content_type='text/markdown',
    platforms=["linux"], 
    python_requires='>=3.7', 
    url="https://github.com/vanyingenzi/mptcplib"
)